use crate::Vec2;

//odd-q vertical layout https://www.redblobgames.com/grids/hexagons
pub struct HexMap {
    size: Vec2<i32>,
    data: Vec<i32>,
    tile_size: Vec2<i32>,
}

impl HexMap {
    //pub static
    pub fn new(size: Vec2<i32>, tile_size: Vec2<i32>) -> Self {
        HexMap {
            size,
            data: vec![0; size.size()],
            tile_size,
        }
    }

    //pub
    pub fn get(&self, coord: Vec2<i32>) -> i32 {
        self.data[self.coord_to_idx(coord)]
    }

    pub fn set(&mut self, coord: Vec2<i32>, val: i32) {
        let idx = self.coord_to_idx(coord);
        self.data[idx] = val;
    }

    pub fn size(&self) -> Vec2<i32> {
        self.size
    }

    //priv
    fn coord_to_idx(&self, coord: Vec2<i32>) -> usize {
        (coord.x + coord.y * self.size.x) as usize
    }
}
